// GDIPlusControlCtl.cpp : Implementation of the CGDIPlusControlCtrl ActiveX Control class.

#include "stdafx.h"
#include "GDIPlusControl.h"
#include "GDIPlusControlCtl.h"
#include "GDIPlusControlPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static InitGDIPlus GDI_Plus_Controler;

IMPLEMENT_DYNCREATE(CGDIPlusControlCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CGDIPlusControlCtrl, COleControl)
	//{{AFX_MSG_MAP(CGDIPlusControlCtrl)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CGDIPlusControlCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CGDIPlusControlCtrl)
	DISP_PROPERTY_NOTIFY(CGDIPlusControlCtrl, "AntiAliased", m_antiAliased, OnAntiAliasedChanged, VT_BOOL)
	DISP_PROPERTY_NOTIFY(CGDIPlusControlCtrl, "Border", m_border, OnBorderChanged, VT_BOOL)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CGDIPlusControlCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CGDIPlusControlCtrl, COleControl)
	//{{AFX_EVENT_MAP(CGDIPlusControlCtrl)
	// NOTE - ClassWizard will add and remove event map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CGDIPlusControlCtrl, 1)
	PROPPAGEID(CGDIPlusControlPropPage::guid)
END_PROPPAGEIDS(CGDIPlusControlCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CGDIPlusControlCtrl, "GDIPLUSCONTROL.GDIPlusControlCtrl.1",
	0xb346a2cc, 0x3ca3, 0x4405, 0x9b, 0xc8, 0x5c, 0xfe, 0x5a, 0x75, 0x15, 0xa3)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CGDIPlusControlCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DGDIPlusControl =
		{ 0x2d84002e, 0xd593, 0x4d1d, { 0xac, 0x2e, 0xda, 0x7e, 0xb2, 0x9b, 0x6b, 0x6e } };
const IID BASED_CODE IID_DGDIPlusControlEvents =
		{ 0x3b12f139, 0x915f, 0x4e81, { 0xa8, 0x8b, 0xa0, 0xcb, 0xad, 0x78, 0xf5, 0xb8 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwGDIPlusControlOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CGDIPlusControlCtrl, IDS_GDIPLUSCONTROL, _dwGDIPlusControlOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CGDIPlusControlCtrl::CGDIPlusControlCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CGDIPlusControlCtrl

BOOL CGDIPlusControlCtrl::CGDIPlusControlCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_GDIPLUSCONTROL,
			IDB_GDIPLUSCONTROL,
			afxRegApartmentThreading,
			_dwGDIPlusControlOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CGDIPlusControlCtrl::CGDIPlusControlCtrl - Constructor

CGDIPlusControlCtrl::CGDIPlusControlCtrl() : m_isClicked(false), m_center(50, 50)
{
	InitializeIIDs(&IID_DGDIPlusControl, &IID_DGDIPlusControlEvents);

	GDI_Plus_Controler.Initialize(); //GDI_Plus_Controler is a static global
}


/////////////////////////////////////////////////////////////////////////////
// CGDIPlusControlCtrl::~CGDIPlusControlCtrl - Destructor

CGDIPlusControlCtrl::~CGDIPlusControlCtrl()
{
	GDI_Plus_Controler.Deinitialize(); //GDI_Plus_Controler is a static global
}


/////////////////////////////////////////////////////////////////////////////
// CGDIPlusControlCtrl::OnDraw - Drawing function

void CGDIPlusControlCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	using namespace Gdiplus;
	Graphics graphics(pdc->m_hDC);
	
	Bitmap bmp(rcBounds.Width(), rcBounds.Height()); // Bitmap sized to control size for double buffering
	Graphics* pMemoryGraphics = Graphics::FromImage(&bmp); // Graphics object using the memory bitmap
	
	LinearGradientBrush blueGradient(Point(1,1), Point(rcBounds.Width()-2, rcBounds.Height()-2), Color(0, 0, 0, 255), Color(192, 0, 0, 255));
	
	// Create path for the ellipse
	GraphicsPath gp;
	gp.StartFigure();
	gp.AddEllipse(2,2, rcBounds.Width() -4, rcBounds.Height() - 4);
	
	// Set up a radial gradient brush
	PathGradientBrush whiteGradientHighlight(&gp);
	whiteGradientHighlight.SetCenterColor(Color(255, 255, 255, 255));
	whiteGradientHighlight.SetCenterPoint(Point(m_center.x, m_center.y)); //m_center is manipulated by the mouse handlers
	whiteGradientHighlight.SetFocusScales(0.1f, 0.1f);
	Color surroundColors[] = {Color(0, 255, 255, 255)};
	int surroundColorsCount = 1;
	whiteGradientHighlight.SetSurroundColors(surroundColors, &surroundColorsCount);
	// Done Setting up radial gradient brush

	if(m_antiAliased)
	{
		pMemoryGraphics->SetSmoothingMode(SmoothingModeAntiAlias);
	}

	pMemoryGraphics->FillPath(&blueGradient, &gp);
	pMemoryGraphics->FillPath(&whiteGradientHighlight, &gp);
	
	if(m_border)
	{
		Pen pen(Color(255,0,0,0), 2);
		pMemoryGraphics->DrawPath(&pen, &gp);
	}

	// using rcBounds.left and rcBounds.top ensure proper positioning with windowless activation.
	graphics.DrawImage(&bmp, rcBounds.left, rcBounds.top);
	
}


/////////////////////////////////////////////////////////////////////////////
// CGDIPlusControlCtrl::DoPropExchange - Persistence support

void CGDIPlusControlCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);
	PX_Bool(pPX, _T("AntiAliased"), m_antiAliased, TRUE);
	PX_Bool(pPX, _T("Border"), m_border, TRUE);
	// TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// CGDIPlusControlCtrl::GetControlFlags -
// Flags to customize MFC's implementation of ActiveX controls.
//
// For information on using these flags, please see MFC technical note
// #nnn, "Optimizing an ActiveX Control".
DWORD CGDIPlusControlCtrl::GetControlFlags()
{
	DWORD dwFlags = COleControl::GetControlFlags();


	// The control can activate without creating a window.
	// TODO: when writing the control's message handlers, avoid using
	//		the m_hWnd member variable without first checking that its
	//		value is non-NULL.
	dwFlags |= windowlessActivate;
	return dwFlags;
}


/////////////////////////////////////////////////////////////////////////////
// CGDIPlusControlCtrl::OnResetState - Reset control to default state

void CGDIPlusControlCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CGDIPlusControlCtrl::AboutBox - Display an "About" box to the user

void CGDIPlusControlCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_GDIPLUSCONTROL);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CGDIPlusControlCtrl message handlers

void CGDIPlusControlCtrl::OnAntiAliasedChanged() 
{
	// TODO: Add notification handler code
	InvalidateRgn(NULL, true);
	SetModifiedFlag();
}

void CGDIPlusControlCtrl::OnBorderChanged() 
{
	// TODO: Add notification handler code
	InvalidateRgn(NULL, true);
	SetModifiedFlag();
}

void CGDIPlusControlCtrl::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	m_center = point;
	m_isClicked = true;
	SetCapture();
	InvalidateRgn(NULL, true);
	COleControl::OnLButtonDown(nFlags, point);
}

void CGDIPlusControlCtrl::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	ReleaseCapture();
	m_center = point;
	m_isClicked = false;
	InvalidateRgn(NULL, true);
	COleControl::OnLButtonUp(nFlags, point);
}

void CGDIPlusControlCtrl::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if(m_isClicked)
	{
		if(m_center.x - point.x > 5 || m_center.x - point.x < -5 || m_center.y - point.y > 5 || m_center.y - point.y < -5)
		{
			m_center = point;
			InvalidateRgn(NULL, true);
		}
	}	COleControl::OnMouseMove(nFlags, point);
}
